package com.grack.prologmachine;

/**
 * The parent interface for all built-in predicates.
 * @author Matthew Mastracci
 */
public interface BuiltInPredicate {
    /**
     * Calls the built-in predicate goal.
     * @param args The arguments passed to the goal.
     * @param m An instance of the PrologMachine.
     * @return True if the goal succeeds, otherwise false.
     */
    public boolean call( Unifiable[] args, PrologMachine m );

    /**
     * Calls the built-in predicate goal through backtracking.
     * @param args The arguments passed to the goal.
     * @param m An instance of the PrologMachine.
     * @return True if the goal succeeds, otherwise false.
     */
    public boolean redo( Unifiable[] args, PrologMachine m );
}
