package com.grack.prologmachine;

import java.util.*;

public class Database {
    private HashMap _procedures;

    /** Groups the procedures by name and arity */
    public class ProcedureGroup {
        private String _name;
        private int _arity;        
        private boolean _isStatic;
        private boolean _isBuiltIn;
        private LinkedList _clauses;

        public ProcedureGroup( PredicateSignature ps, boolean isStatic, boolean isBuiltIn ) {
            _name = ps.getName();
            _arity = ps.getArity();
            _isStatic = isStatic;
            _isBuiltIn = isBuiltIn;
            _clauses = new LinkedList();
        }

        public void AppendHead( Clause c ) {
            _clauses.addFirst( c );
        }

        public void AppendTail( Clause c ) {            
            _clauses.addLast( c );
        }
        
        public boolean isStatic() {
            return _isStatic;
        }        
        public boolean isBuiltIn() {
            return _isBuiltIn;
        }
    }

    public void AppendHead( Clause c ) {
    }
    public void AppendTail( Clause c ) {
    }

    public ProcedureGroup getGroup( PredicateSignature ps ) {
        return (ProcedureGroup)_procedures.get( ps );
    }
}


