package com.grack.prologmachine;

import java.util.*;

/*
 * An ISO Prolog-compliant Prolog Machine.
 */

public class PrologMachine {
    public class Substitution { }
    public class BacktrackingInfo { }
    
    public class ExecutionState {
        private int _index;
        private LinkedList _decoratedSubgoalStack;
        private Substitution _subst;
        private BacktrackingInfo _bi;

        public PredicateSignature getCurrAct() {
            return ((DecoratedSubgoal)_decoratedSubgoalStack.get( 0 ))._activator;
        }

        public ExecutionState deepClone() {
            ExecutionState es = null;
            try {
                es = (ExecutionState)clone();
                es._decoratedSubgoalStack = new LinkedList();
                for ( int i = 0; i < _decoratedSubgoalStack.size(); i++ ) {
                    es._decoratedSubgoalStack.addLast( _decoratedSubgoalStack.get( i ) );
                }
            } catch ( Exception e ) {
                e.printStackTrace();
            }

            return es;
        }

        public boolean isBuiltIn() {
            return false;
        }

        public boolean isSuccess() {
            return ( _decoratedSubgoalStack.size() == 0 );
        }

        public boolean isUserProcedure() {
            return false;
        }

        private class DecoratedSubgoal {
            private PredicateSignature _activator;
            private int _cutParent;
        }
    }

    public class ExecutionStack {
        private LinkedList _stack;

        public ExecutionState top() {
            return (ExecutionState)_stack.getLast();
        }

        public void pop() {
            _stack.removeLast();
        }

        public void copyTop() {
            _stack.addLast( top().deepClone() );
        }

        public boolean isSuccess() {
            return top.isSuccess();
        }

        public boolean isFailure() {
            return ( _stack.size() == 0 );
        }

        public void loadUnifiable( Unifiable u ) {
        }
    }

    ExecutionStack _es;

    public void Solve( Unifiable u ) {
        _es.loadUnifiable( u );
        while ( !_es.isSuccess() && !_es.isFailure() ) {
            PredicateSignature ps = _es.top().getCurrAct();
            /*
              ProcedureGroup pg = _db.getProcedureGroup( ps );
              if ( pg.isBuiltIn() ) {
              // builtin
              } else {
              // user
              }
            */
        }
    }

    public ExecutionStack getExecutionStack() {
        return _es;
    }
}

